
import 'package:bird/signal_wave.dart';
import 'package:bird_flutter/flutter_apply.dart';
import 'package:bird_flutter/flutter_apply_hooked.dart';

BuildApplicator<Wave<Applicator>, Applicator> buildApplicator = BuildApplicator((wave) {
  return apply((child) => $$ >> (context) => $(() => wave) > child);
});

class BuildApplicator<F, T> {
  T applyThis(F a) => _apply(a);

  final T Function(F) _apply;

  const BuildApplicator(this._apply);

  T operator >(F w) => applyThis(w);

  T call(F n) => applyThis(n);
}

